//+------------------------------------------------------------------+
//|                                             SHI_Channel_true.mq4 |
//|                                 Copyright  2004, Shurka & Kevin |
//|                                                                  |
//+------------------------------------------------------------------+
//| SHI_Channel_true_TRO_MODIFIED_VERSION                            |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "Copyright  2004, Shurka & Kevin"
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Pink

 
//+--------- TRO MODIFICATION ---------------------------------------+ 

extern bool   Show.Gauge  = true ;
extern int myChartX   = 10 ;
extern int myChartY   = 300 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;


extern bool   Sound.Alert    = false ;
extern bool   Show.MidLine   = true ;
extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth     = 3;

extern bool   Show.Comment   = false ;

extern color colorHead = Orange ;
extern color colorTop  =  Chocolate ;
extern color colorMid  =  Chocolate ;
extern color colorBot  =  Chocolate ;
extern color colorUp   = Lime ;
extern color colorEq   = Yellow ;
extern color colorDn   = Red ;



double ExtMapBuffer1[];
//---- input parameters


extern int AllBars = 240;
extern int BarsForFract = 0;


int CurrentBar = 0;
double Step = 0;
int B1 = -1, B2 = -1;
int UpDown = 0;
double P1 = 0, P2 = 0, PP = 0;
int i = 0, AB = 300, BFF = 0;
int ishift = 0;
double iprice = 0;
datetime T1, T2;

//+--------- TRO MODIFICATION ---------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

datetime Trigger ;

int OldBars = -1 ;

color tColor = Yellow ;
color TL1color      = White ;
double UpperLR, LowerLR, MiddleLR ; 
 

string lbl[15], lbl2[15];

int n, j ;

int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;  

string ShortName, ObjG001,ObjG002,ObjG003,ObjG004,ObjG005,ObjG006,ObjG007,ObjG008,ObjG009,Obj0010,Obj0011;  

double close, diff, value, point, range, xPct ;


color pColor = Blue ; 
 
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//+--------- TRO MODIFICATION ---------------------------------------+  
  
   period       = Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   

   tShortName = "shict"+ symbol  ; // + tChartPeriod 
   ShortName  = "shict" ;
   
//+--------- TRO MODIFICATION ---------------------------------------+   
  
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 164);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexEmptyValue(0, 0.0);
//----

 
   
if( myCorner == 0 || myCorner == 2 )
{  
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 10 ; //  
   x003 = 60 ;  // val  
   x004 = 0 ; //  dif
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;  
   FillAmt = 23 ; 
}


    deinit();
   
    
   return(0);
  }

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
       
   ObDeleteObjectsByPrefix("shict"); 
   
   TRO() ;   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {

//+--------- TRO MODIFICATION ---------------------------------------+   
//   if( Bars != OldBars ) { Trigger = True ; }
 

   int counted_bars = IndicatorCounted();
//---- 
      if((AllBars == 0) || (Bars < AllBars)) 
          AB = Bars; 
      else AB = AllBars; //AB-?????????? ????????????? ?????
      if(BarsForFract > 0) 
             BFF = BarsForFract; 
      else
             switch (Period())
               {
                    case     1: BFF = 12; break;
                    case     5: BFF = 24; break; // was 48
                    case    15: BFF = 24; break;
                    case    30: BFF = 24; break;
                    case    60: BFF = 12; break;
                    case   240: BFF = 15; break;
                    case  1440: BFF = 10; break;
                    case 10080: BFF = 6;  break;
                    case 43200: BFF = 6;  break;                    
                    default:  return(-1); break;
               }
   CurrentBar = 2; //??????? ? ???????? ????, ????? ??????? "??????????
   B1 = -1; 
   B2 = -1; 
   UpDown = 0;
   while(((B1 == -1) || (B2==-1)) && (CurrentBar<AB))
     {
             //UpDown = 1 ?????? ?????? ??????? ?????? ??????, UpDown = -1 ?????? ?????? ???????
             //?????? ?????, UpDown = 0 ?????? ??????? ??? ?? ??????.
             //?1 ? ?2 - ?????? ????? ? ??????????, ????? ??? ?????? ??????? ?????.
             //?1 ? ?2 - ?????????????? ???? ????? ??????? ????? ????? ?????????
             if((UpDown < 1) && (CurrentBar == Lowest(Symbol(), Period(), MODE_LOW, BFF*2 + 1,
                CurrentBar - BFF))) 
               {
                    if(UpDown == 0) 
                      { 
                        UpDown = -1; 
                        B1 = CurrentBar; 
                        P1 = Low[B1]; 
                      }
                    else 
                      { 
                        B2 = CurrentBar; 
                        P2 = Low[B2];
                      }
               }
             if((UpDown > -1) && (CurrentBar == Highest(Symbol(), Period(), MODE_HIGH, BFF*2 + 1,
                CurrentBar - BFF))) 
               {
                    if(UpDown == 0) 
                      { 
                        UpDown = 1; 
                        B1 = CurrentBar; 
                        P1 = High[B1]; 
                      }
                    else 
                      { 
                        B2 = CurrentBar; 
                        P2 = High[B2]; 
                      }
               }
             CurrentBar++;
        }
      if((B1 == -1) || (B2 == -1)) 
        {
          deinit(); 
          return(-1);
        } // ?????? ?? ????? ????????? ????? 300 ????? 8-)
      Step = (P2 - P1) / (B2 - B1); //????????? ???, ???? ?? ?????????????, ?? ????? ??????????
      P1 = P1 - B1*Step; 
      B1 = 0; //???????????? ???? ? ?????? ??? ? ????
//? ?????? ??????? ????? ??????????????? ????? ??????.
      ishift = 0; 
      iprice = 0;
      if(UpDown == 1)
        { 
             PP = Low[2] - 2*Step;
             for(i = 3; i <= B2; i++) 
               {
                    if(Low[i] < PP + Step*i) 
                        PP = Low[i] - i*Step; 
               }
             if(Low[0] < PP) 
               {
                 ishift = 0; 
                 iprice = PP;
               }
             if(Low[1] < PP + Step) 
               {
                 ishift = 1; 
                 iprice = PP + Step;
               }
             if(High[0] > P1) 
               {
                 ishift = 0; 
                 iprice = P1;
               }
             if(High[1] > P1 + Step) 
               {
                 ishift = 1; 
                 iprice = P1 + Step;
               }
        } 
      else
        { 
             PP = High[2] - 2*Step;
             for(i = 3; i <= B2; i++) 
               {
                    if(High[i] > PP + Step*i) 
                        PP = High[i] - i*Step;
               }
             if(Low[0] < P1) 
               {
                 ishift = 0; 
                 iprice = P1;
               }
             if(Low[1] < P1 + Step) 
               {
                 ishift = 1; 
                 iprice = P1 + Step;
               }
             if(High[0] > PP) 
               {
                 ishift = 0; 
                 iprice = PP;
               }
             if(High[1] > PP + Step) 
               {
                 ishift = 1; 
                 iprice = PP + Step;
               }
        }
//?????? ?????????? ???????? ???? ? ??? ?? ??, ????? ????? ?????? ?????????? ?????????
      P2 = P1 + AB*Step;
      T1 = Time[B1]; 
      T2 = Time[AB];
//???? ?? ???? ??????????? ??????, ?? 0, ????? ?????? ?????.


//+--------- TRO MODIFICATION ---------------------------------------+  
double xChannelSize = MathAbs(PP - P1) / Point ;
double xSlope       = -Step / Point ;


double qq1 = NormalizeDouble(PP,digits) ;
double qq2 = NormalizeDouble(P1,digits) ;

      LowerLR  = MathMin(qq1,qq2) ;
      UpperLR  = MathMax(qq1,qq2) ;
      MiddleLR = NormalizeDouble((P1 + PP) / 2 ,digits) ;     
                     
      if(xSlope > 0) { TL1color = colorUp ; } else {
      if(xSlope < 0) { TL1color = colorDn ;  } else { TL1color = colorEq ;  }  }    
      
      if( Show.Comment )
      {
         Comment(" Channel size = ", DoubleToStr(xChannelSize, 0), " Slope = ", DoubleToStr(xSlope, 2) , "\n",
                 " LowerLR = ", DoubleToStr(LowerLR, digits), " UpperLR = ", DoubleToStr(UpperLR, digits) , "\n",
                 " LinReg  = ", DoubleToStr(MiddleLR, digits),  " Close[0] = ", DoubleToStr(Close[0], digits) , "\n",
         "");
      }        

//+--------- TRO MODIFICATION ---------------------------------------+             
           
                 
      if(iprice != 0) 
          ExtMapBuffer1[ishift] = iprice;
      deinit();
      
      
      ObjectCreate(tShortName+"TL1", OBJ_TREND, 0, T2, PP + Step*AB, T1, PP);  // lower line
         ObjectSet(tShortName+"TL1", OBJPROP_COLOR, TL1color); 
         ObjectSet(tShortName+"TL1", OBJPROP_WIDTH, 2); 
         ObjectSet(tShortName+"TL1", OBJPROP_STYLE, STYLE_SOLID); 
         ObjectSet(tShortName+"TL1", OBJPROP_RAY, false) ; 
         ObjectSet(tShortName+"TL1", OBJPROP_BACK, true) ;
         
      ObjectCreate(tShortName+"TL2", OBJ_TREND, 0, T2, P2, T1, P1); // upper line
         ObjectSet(tShortName+"TL2", OBJPROP_COLOR, TL1color); 
         ObjectSet(tShortName+"TL2", OBJPROP_WIDTH, 2); 
         ObjectSet(tShortName+"TL2", OBJPROP_STYLE, STYLE_SOLID); 
         ObjectSet(tShortName+"TL2", OBJPROP_RAY, false) ; 
         ObjectSet(tShortName+"TL2", OBJPROP_BACK, true) ;     
         
      if(Show.MidLine) 
      {             
      ObjectCreate(tShortName+"MIDL", OBJ_TREND, 0, T2, (P2 + PP + Step*AB) / 2, T1, (P1 + PP) / 2);
         ObjectSet(tShortName+"MIDL", OBJPROP_COLOR, TL1color); 
         ObjectSet(tShortName+"MIDL", OBJPROP_WIDTH, 1); 
         ObjectSet(tShortName+"MIDL", OBJPROP_STYLE, STYLE_DOT);
         ObjectSet(tShortName+"MIDL", OBJPROP_RAY, false) ; 
         ObjectSet(tShortName+"MIDL", OBJPROP_BACK, true) ;
      }        



//+--------- TRO MODIFICATION ---------------------------------------+  
      
      if ( Trigger != Time[0] &&  Sound.Alert ) 
      {
        if( Close[0] >= UpperLR ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Price at/above UpperLR "+ DoubleToStr(UpperLR ,digits)); }
        if( Close[0] <= LowerLR ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " Price at/below LowerLR "+ DoubleToStr(LowerLR ,digits)); }     
      }

   if(Show.PriceBox) { DoBox() ; }

      
   if(Show.Gauge) { DoShowGauge(); }
    
   OldBars = Bars ;   
   

   WindowRedraw() ;

//+--------- TRO MODIFICATION ---------------------------------------+                  
   return(0);
}

//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{


       if (ObjectFind(tShortName+"01") != 0)
      {
          ObjectCreate(tShortName+"01",OBJ_ARROW,0,Time[0],UpperLR);
          ObjectSet(tShortName+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"01",OBJPROP_COLOR,TL1color);  
          ObjectSet(tShortName+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"01",0,Time[0],UpperLR);
         ObjectSet(tShortName+"01",OBJPROP_COLOR,TL1color);  
      }

       if (ObjectFind(tShortName+"02") != 0)
      {
          ObjectCreate(tShortName+"02",OBJ_ARROW,0,Time[0],LowerLR);
          ObjectSet(tShortName+"02",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"02",OBJPROP_COLOR,TL1color);  
          ObjectSet(tShortName+"02",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"02",0,Time[0],LowerLR);
         ObjectSet(tShortName+"02",OBJPROP_COLOR,TL1color);  
      }

       if(Show.MidLine) {
       if (ObjectFind(tShortName+"03") != 0)
      {
          ObjectCreate(tShortName+"03",OBJ_ARROW,0,Time[0],MiddleLR);
          ObjectSet(tShortName+"03",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"03",OBJPROP_COLOR,TL1color);  
          ObjectSet(tShortName+"03",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"03",0,Time[0],MiddleLR);
         ObjectSet(tShortName+"03",OBJPROP_COLOR,TL1color);  
      }
      } //if(Show.MidLine) {



                
   return(0);
}


//+--------- TRO MODIFICATION ---------------------------------------+  

//+------------------------------------------------------------------+


void DoShowGauge()
{
n       = 10;
j       = 0 ;

close   = iClose(symbol,period,0) ;

lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + " Shi Channel(" + AllBars   +")"  , FillAmt) ;
DoShow(j, colorHead);


j       = j + 1;
lbl[j]  = ShortName+j;
value   = UpperLR ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Upper SC"  , FillAmt) ;
DoShow(j, pColor);


j       = j + 1;
lbl[j]  = ShortName+j;
value   = MiddleLR ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Middle SC"  , FillAmt) ;
DoShow(j, pColor);


j       = j + 1;
lbl[j]  = ShortName+j;
value   = LowerLR ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Lower SC"  , FillAmt) ;
DoShow(j, pColor);



j       = j + 1;
lbl[j]  = ShortName+j;
value   = (UpperLR - LowerLR) / point  ;
diff    = 100 * ( close - LowerLR) /  (UpperLR - LowerLR)  ;
DoColor(diff, 50) ;
lbl2[j] = fFill("Range| %"  , FillAmt) ;
DoShow(j, pColor);


}


//+------------------------------------------------------------------+

void DoShow( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

if(u > 0)
{
string Obj001 = lbl[u] + "val" ;
string sVal = fFill(DoubleToStr(value,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "dif" ;
string sDif =  rtadjust( DoubleToStr(diff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,dsColor);
}

n = n+20;

return(0);

}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = colorUp ; } else {
if(c1 < c2 ) { pColor = colorDn ; } else { pColor = colorEq ; } } 

}  
   
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

 


//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       



//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+--------- TRO MODIFICATION ---------------------------------------+  
/*

Comment(

"j   = " , j   , "\n" ,   
"diff " , DoubleToStr(diff,Digits) , "\n" ,     
"") ; 



*/