//+------------------------------------------------------------------+ 
//|   TRO_Linear Regression_Auto                                     | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+
//|                                            Linear Regression.mq4 |
//|                Copyright  2006, tageiger, aka fxid10t@yahoo.com |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//#property copyright "Copyright  2006, tageiger, aka fxid10t@yahoo.com"
//#property link      "http://www.metaquotes.net"


#property indicator_chart_window 



extern int    myChartY       = 400 ;

extern string myFont         = "Courier" ; // "Verdana"
extern int    myFontSize     = 12 ;  

extern bool   Show.Comment   = false ;
extern bool   Show.Gauge     = true ;
extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth     = 2;

extern int    myPeriod       = 0;


/*default 0 means the channel will use the open time from "x" bars back on which ever time period 
the indicator is attached to.  one can change to 1,5,15,30,60...etc to "lock" the start time to a specific 
period, and then view the "locked" channels on a different time period...*/

extern int myShift=0; // if 1 or more static lines

extern int line.width = 2;
extern int myLR.length = 0;   // bars back regression begins
extern color  LR.c = Orange;
extern double std.channel.1 = 1.0;        // 1st channel
extern color  c.1 = Gray;
extern double std.channel.2 = 2.0;        // 2nd channel
extern color  c.2 = Gray;
extern double std.channel.3 = 3.0;        // 3nd channel
extern color  c.3 = Gray;

extern color myColorH = LightSalmon ;
extern color myColor1 = DodgerBlue ;
extern color myColor2 = DodgerBlue ;
extern color myColor3 = DodgerBlue ;

extern color colorUp =  Lime ;
extern color colorEq =  Yellow ;
extern color colorDn =  Red ;


double ULR1   ;
double LLR1   ;

double ULR2   ;
double LLR2   ;

double ULR3   ;
double LLR3   ;

string TAG = "LRA" , OBJNAME ;

string tULR1 ;
string tLLR1  ;
string tULR2  ;
string tLLR2  ;
string tULR3  ;
string tLLR3  ;




//+------------------------------------------------------------------+

int    digits, win ; 

double point, close, LR.price.2,  LinReg, LRrange, LinRegPct, LRClose,std.dev=0 ;  
double X01,X02,X03,X04,X05 ;
double X06 ;   
double X07 ;
double X08, X09, X10, X11; 

string symbol, tChartPeriod ;  
string dHead01, dHead02;
string dLabel01, dValue01;
string dLabel02, dValue02;
string dLabel03, dValue03;
string dLabel04, dValue04;
string dLabel05, dValue05;
string dLabel06, dValue06;
string dLabel07, dValue07;
string dLabel08, dValue08;
string dLabel09, dValue09;
string dLabel10, dValue10;
string dLabel11, dValue11;


int xBarsPerChart ,period   ; 
int LR.length = 0;   

//+------------------------------------------------------------------+
int init(){

//ObjectsDeleteAll(); 




   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   win          = 0 ;
   
   OBJNAME = TAG + myLR.length ; 
      
   
 dHead01=OBJNAME+"llrh01"+ tChartPeriod ;  dHead02=OBJNAME+"llr202"+ tChartPeriod ;     
    
 dLabel01=OBJNAME+"llr01"+ tChartPeriod ;  dValue01=OBJNAME+"llrv01"+ tChartPeriod ; 
 dLabel02=OBJNAME+"llr02"+ tChartPeriod ;  dValue02=OBJNAME+"llrv02"+ tChartPeriod ; 
 dLabel03=OBJNAME+"llr03"+ tChartPeriod ;  dValue03=OBJNAME+"llrv03"+ tChartPeriod ; 
 dLabel04=OBJNAME+"llr04"+ tChartPeriod ;  dValue04=OBJNAME+"llrv04"+ tChartPeriod ; 
 dLabel05=OBJNAME+"llr05"+ tChartPeriod ;  dValue05=OBJNAME+"llrv05"+ tChartPeriod ; 
 dLabel06=OBJNAME+"llr06"+ tChartPeriod ;  dValue06=OBJNAME+"llrv06"+ tChartPeriod ; 
 dLabel07=OBJNAME+"llr07"+ tChartPeriod ;  dValue07=OBJNAME+"llrv07"+ tChartPeriod ; 
 dLabel08=OBJNAME+"llr08"+ tChartPeriod ;  dValue08=OBJNAME+"llrv08"+ tChartPeriod ; 
 dLabel09=OBJNAME+"llr09"+ tChartPeriod ;  dValue09=OBJNAME+"llrv09"+ tChartPeriod ; 
 dLabel10=OBJNAME+"llr10"+ tChartPeriod ;  dValue10=OBJNAME+"llrv10"+ tChartPeriod ; 
 dLabel11=OBJNAME+"llr11"+ tChartPeriod ;  dValue11=OBJNAME+"llrv11"+ tChartPeriod ;    
  

 tULR1 = OBJNAME+"ULR1" ;
 tLLR1 = OBJNAME+"llr1" ;
 tULR2 = OBJNAME+"ULR2" ;
 tLLR2 = OBJNAME+"llr2" ;
 tULR3 = OBJNAME+"ULR3" ;
 tLLR3 = OBJNAME+"llr3" ;
  
   
return(0);}

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
//+------------------------------------------------------------------+
int deinit()
{ 

//   ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" TL"); 
//   ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.1+"d"); ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.1+"d");
//   ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.2+"d"); ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.2+"d");
//   ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.3+"d"); ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.3+"d");

         ObjectDelete("U_LR");
         ObjectDelete("M_LR");
         ObjectDelete("L_LR");
         ObjectDelete("L_LR");         
         ObjectDelete(tULR1);  
         ObjectDelete(tLLR1);  
         ObjectDelete(tULR2);  
         ObjectDelete(tLLR2);           
         ObjectDelete(tULR3);  
         ObjectDelete(tLLR3);  
         
   ObDeleteObjectsByPrefix(OBJNAME+"llr");  
 
                           
return(0);}

//+------------------------------------------------------------------+
int start(){//refresh chart

deinit() ;

if(myLR.length == 0) {   LR.length    = WindowBarsPerChart() ;  } else { LR.length = myLR.length ; }


ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" TL");
ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.1+"d"); ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.1+"d");
ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.2+"d"); ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.2+"d");
ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.3+"d"); ObjectDelete(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.3+"d");
//linear regression calculation

int start.bar = LR.length, end.bar = 0 + myShift;

   int n=start.bar-end.bar+1;
//---- calculate price values
   double value=iClose(Symbol(),period,end.bar);
   double a,b,c;
   double sumy=value;
   double sumx=0.0;
   double sumxy=0.0;
   double sumx2=0.0;
   for(int i=1; i<n; i++)
     {
      value=iClose(Symbol(),period,end.bar+i);
      sumy+=value;
      sumxy+=value*i;
      sumx+=i;
      sumx2+=i*i;
     }
   c=sumx2*n-sumx*sumx;
   if(c==0.0) return;
   b=(sumxy*n-sumx*sumy)/c;
   a=(sumy-sumx*b)/n;
          LR.price.2=a;
   double LR.price.1=a+b*n;

//---- maximal deviation calculation (not used)
   double max.dev=0;
   double deviation=0;
   double dvalue=a;
   for(i=myShift; i<n; i++)
     {
      value=iClose(Symbol(),period,end.bar+i);
      dvalue+=b;
      deviation=MathAbs(value-dvalue);
      if(max.dev<=deviation) max.dev=deviation;
     }
//Linear regression trendline
   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" TL",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1,Time[end.bar],LR.price.2);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" TL",OBJPROP_COLOR,LR.c);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" TL",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" TL",OBJPROP_RAY,false);     
//...standard deviation...
   double x=0,x.sum=0,x.avg=0,x.sum.squared=0;
   for(i=0; i<start.bar; i++)    {
      x=MathAbs(iClose(Symbol(),period,i)-ObjectGetValueByShift(OBJNAME+"llr"+period+"m "+LR.length+" TL",i));
      x.sum+=x;
      if(i>0)  {
         x.avg=(x.avg+x)/i;
         x.sum.squared+=(x-x.avg)*(x-x.avg);
         std.dev=MathSqrt(x.sum.squared/(start.bar-1));  }  }
   //Print("LR.price.1 ",LR.price.1,"  LR.Price.2 ",LR.price.2," std.dev ",std.dev);
//...standard deviation channels...

ULR1 = LR.price.2+std.dev*std.channel.1 ;
LLR1 = LR.price.2-std.dev*std.channel.1 ;

ULR2 = LR.price.2+std.dev*std.channel.2 ;
LLR2 = LR.price.2-std.dev*std.channel.2 ;

ULR3 = LR.price.2+std.dev*std.channel.3 ;
LLR3 = LR.price.2-std.dev*std.channel.3 ;

LRClose   = iClose(symbol,period,0) ;
LRrange   = LR.price.2 + std.dev * 1.0 ;
LinRegPct = 100 * ( LRClose - LR.price.2 ) / std.dev ;


   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.1+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1+std.dev*std.channel.1,
                                        Time[end.bar],LR.price.2+std.dev*std.channel.1);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.1+"d",OBJPROP_COLOR,c.1);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.1+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.1+"d",OBJPROP_RAY,false);
   
   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.1+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1-std.dev*std.channel.1,
                                             Time[end.bar],LR.price.2-std.dev*std.channel.1);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.1+"d",OBJPROP_COLOR,c.1);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.1+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.1+"d",OBJPROP_RAY,false);

   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1+std.dev*std.channel.2,
                                             Time[end.bar],LR.price.2+std.dev*std.channel.2);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.2+"d",OBJPROP_COLOR,c.2);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.2+"d",OBJPROP_RAY,false);
   
   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.2+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1-std.dev*std.channel.2,
                                             Time[end.bar],LR.price.2-std.dev*std.channel.2);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.2+"d",OBJPROP_COLOR,c.2);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.2+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.2+"d",OBJPROP_RAY,false);

   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.3+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1+std.dev*std.channel.3,
                                             Time[end.bar],LR.price.2+std.dev*std.channel.3);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.3+"d",OBJPROP_COLOR,c.3);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.3+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" +"+std.channel.3+"d",OBJPROP_RAY,false);
   
   ObjectCreate(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.3+"d",OBJ_TREND,0,iTime(Symbol(),period,start.bar),LR.price.1-std.dev*std.channel.3,
                                             Time[end.bar],LR.price.2-std.dev*std.channel.3);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.3+"d",OBJPROP_COLOR,c.3);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.3+"d",OBJPROP_WIDTH,line.width);
   ObjectSet(OBJNAME+"llr"+period+"m "+LR.length+" -"+std.channel.3+"d",OBJPROP_RAY,false);
     

if( Show.Gauge ) { DoShowGauge() ; }

if(Show.PriceBox) { DoPriceBox() ; }

if(Show.Comment ) 
{   
   Comment(  
   "Bars Per Chart    =  ", LR.length , "\n",
   "LR.price.2.... ", DoubleToStr(LR.price.2,Digits) ,"\n",
   "std.dev....... ", DoubleToStr(std.dev,Digits) ,"\n",   
   "LRrange....... ", DoubleToStr(LRrange,Digits) ,"\n",            
   "");     
}   
      
WindowRedraw() ;      
                
return(0);
}

//+------------------------------------------------------------------+ 

void DoShowGauge()
{

X01  = ULR1 ;
X02  = LR.price.2 ;
X03  = LLR1 ;
X04  = ULR2 ;
X05  = LR.price.2 ;
X06  = LLR2 ;
X07  = ULR3  ;
X08  = LR.price.2 ;
X09  = LLR3 ;
X10  = std.dev ;
X11  = LinRegPct ;


string StrH   = " LR(" + LR.length + ") Gauge" ;
string StrX01 = DoubleToStr(std.channel.1,0) + " Top   " ; 
string StrX02 = DoubleToStr(std.channel.1,0) + " Mid   " ; 
string StrX03 = DoubleToStr(std.channel.1,0) + " Bot   " ; 
string StrX04 = DoubleToStr(std.channel.2,0) + " Top   " ;  
string StrX05 = DoubleToStr(std.channel.2,0) + " Mid   " ; 
string StrX06 = DoubleToStr(std.channel.2,0) + " Bot   " ;
string StrX07 = DoubleToStr(std.channel.3,0) + " Top   " ;
string StrX08 = DoubleToStr(std.channel.3,0) + " Mid   " ;  
string StrX09 = DoubleToStr(std.channel.3,0) + " Bot   " ;  
string StrX10 = "Std Dev " ;  
string StrX11 = "Std Dev%" ;  

  
color color_X01=c.1;
color color_X02=LR.c;
color color_X03=c.1;  
color color_X04=c.2;
color color_X05=LR.c;
color color_X06=c.2;
color color_X07=c.3;  
color color_X08=LR.c;  
color color_X09=c.3; 
color color_X10 = myColorH ; 
color color_X11 ;

if( X11 >= 0 ) { color_X11 = colorUp  ; } else  { color_X11 = colorDn  ; }

/*  
color color_X10=myColor10; 

*/


close = iClose(NULL,period,0) ;    

if( close  > ULR1        ) { color_X01 = Lime ; } else { color_X01 = Red ; } 
if( close  > LR.price.2  ) { color_X02 = Lime ; } else { color_X02 = Red ; } 
if( close  > LLR1        ) { color_X03 = Lime ; } else { color_X03 = Red ; }   

if( close  > ULR2        ) { color_X04 = Lime ; } else { color_X04 = Red ; } 
if( close  > LR.price.2  ) { color_X05 = Lime ; } else { color_X05 = Red ; } 
if( close  > LLR2        ) { color_X06 = Lime ; } else { color_X06 = Red ; }  

if( close  > ULR3        ) { color_X07 = Lime ; } else { color_X07 = Red ; } 
if( close  > LR.price.2  ) { color_X08 = Lime ; } else { color_X08 = Red ; } 
if( close  > LLR3        ) { color_X09 = Lime ; } else { color_X09 = Red ; }  

//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_vSRFP, Xdist_text, Xdist_vSRFP;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_X01, Ydist_X02, Ydist_X03, Ydist_X04, Ydist_X05, Ydist_X06, Ydist_X07, Ydist_X08, Ydist_X09, Ydist_X10, Ydist_X11 ;
  
   int YdistInc ;
   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_vSRFP = 1;
    Xdist_line = 21; Xdist_text = 93; Xdist_vSRFP = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    
    Ydist_X01 = Ydist_pivots + 25; 
    Ydist_X02 = Ydist_X01 + YdistInc; 
    Ydist_X03 = Ydist_X01 + YdistInc*2; 
    Ydist_X04 = Ydist_X01 + YdistInc*3; 
    Ydist_X05 = Ydist_X01 + YdistInc*4;
    Ydist_X06 = Ydist_X01 + YdistInc*5;    
    Ydist_X07 = Ydist_X01 + YdistInc*6;
    Ydist_X08 = Ydist_X01 + YdistInc*7;    
    Ydist_X09 = Ydist_X01 + YdistInc*8;    
    Ydist_X10 = Ydist_X01 + YdistInc*9;    
    Ydist_X11 = Ydist_X01 + YdistInc*10;  
    
//+------------------------------------------------------------------+ 
   ObjectCreate(dHead01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead01,tChartPeriod + StrH,myFontSize, myFont, myColorH);
   ObjectSet(dHead01, OBJPROP_CORNER, Corner_pivots);
   ObjectSet(dHead01, OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet(dHead01, OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate(dHead02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead02,"-----------------",myFontSize, myFont, myColorH);
   ObjectSet(dHead02, OBJPROP_CORNER, Corner_line);
   ObjectSet(dHead02, OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet(dHead02, OBJPROP_YDISTANCE, Ydist_line5);

//+------------------------------------------------------------------+    

if(std.channel.1 > 0) 
{
   ObjectCreate(dLabel01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel01,StrX01,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel01, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel01, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel01, OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate(dValue01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue01," "+DoubleToStr(X01,digits),myFontSize, myFont, color_X01);
   ObjectSet(dValue01, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue01, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue01, OBJPROP_YDISTANCE, Ydist_X01);

//+------------------------------------------------------------------+     
   ObjectCreate(dLabel02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel02,StrX02,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel02, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel02, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel02, OBJPROP_YDISTANCE, Ydist_X02);
   
   ObjectCreate(dValue02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue02," "+DoubleToStr(X02,digits),myFontSize, myFont, color_X02);
   ObjectSet(dValue02, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue02, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue02, OBJPROP_YDISTANCE, Ydist_X02);

//+------------------------------------------------------------------+ 
   ObjectCreate(dLabel03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel03,StrX03,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel03, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel03, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel03, OBJPROP_YDISTANCE, Ydist_X03);
   
   ObjectCreate(dValue03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue03," "+DoubleToStr(X03,digits),myFontSize, myFont, color_X03);
   ObjectSet(dValue03, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue03, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue03, OBJPROP_YDISTANCE, Ydist_X03);
}
//+------------------------------------------------------------------+ 
if(std.channel.2 > 0) 
{

   ObjectCreate(dLabel04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel04,StrX04,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel04, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel04, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel04, OBJPROP_YDISTANCE, Ydist_X04);
   
   ObjectCreate(dValue04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue04," "+DoubleToStr(X04,digits),myFontSize, myFont, color_X04);
   ObjectSet(dValue04, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue04, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue04, OBJPROP_YDISTANCE, Ydist_X04);  

//+------------------------------------------------------------------+    
   ObjectCreate(dLabel05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel05,StrX05,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel05, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel05, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel05, OBJPROP_YDISTANCE, Ydist_X05);
   
   ObjectCreate(dValue05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue05," "+DoubleToStr(X05,digits),myFontSize, myFont, color_X05);
   ObjectSet(dValue05, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue05, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue05, OBJPROP_YDISTANCE, Ydist_X05);

//+------------------------------------------------------------------+     
   ObjectCreate(dLabel06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel06,StrX06,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel06, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel06, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel06, OBJPROP_YDISTANCE, Ydist_X06);
   
   ObjectCreate(dValue06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue06," "+DoubleToStr(X06,digits),myFontSize, myFont, color_X06);
   ObjectSet(dValue06, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue06, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue06, OBJPROP_YDISTANCE, Ydist_X06);
}
if(std.channel.3 > 0) 
{
   ObjectCreate(dLabel07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel07,StrX07,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel07, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel07, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel07, OBJPROP_YDISTANCE, Ydist_X07);
   
   ObjectCreate(dValue07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue07," "+DoubleToStr(X07,digits),myFontSize, myFont, color_X07);
   ObjectSet(dValue07, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue07, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue07, OBJPROP_YDISTANCE, Ydist_X07);

   ObjectCreate(dLabel08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel08,StrX08,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel08, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel08, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel08, OBJPROP_YDISTANCE, Ydist_X08);
   
   ObjectCreate(dValue08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue08," "+DoubleToStr(X08,digits),myFontSize, myFont, color_X08);
   ObjectSet(dValue08, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue08, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue08, OBJPROP_YDISTANCE, Ydist_X08);  
  
   ObjectCreate(dLabel09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel09,StrX09,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel09, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel09, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel09, OBJPROP_YDISTANCE, Ydist_X09);
   
   ObjectCreate(dValue09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue09," "+DoubleToStr(X09,digits),myFontSize, myFont, color_X09);
   ObjectSet(dValue09, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue09, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue09, OBJPROP_YDISTANCE, Ydist_X09);  

}
 
   
   ObjectCreate(dLabel10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel10,StrX10,myFontSize, myFont, color_X10 );
   ObjectSet(dLabel10, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel10, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel10, OBJPROP_YDISTANCE, Ydist_X10);
   
   ObjectCreate(dValue10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue10," "+DoubleToStr(X10,digits),myFontSize, myFont, color_X10);
   ObjectSet(dValue10, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue10, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue10, OBJPROP_YDISTANCE, Ydist_X10);  
  
  ObjectCreate(dLabel11, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel11,StrX11,myFontSize, myFont, color_X11 );
   ObjectSet(dLabel11, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel11, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel11, OBJPROP_YDISTANCE, Ydist_X11);
   
   ObjectCreate(dValue11, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue11," "+ DoubleToStr(X11,0) + "%" ,myFontSize, myFont, color_X11);
   ObjectSet(dValue11, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue11, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue11, OBJPROP_YDISTANCE, Ydist_X11);  
    
  
}

void DoPriceBox()
{
if( std.channel.1 != 0 ) 
{
      
    if (ObjectFind(tULR1) != 0)
      {
          ObjectCreate(tULR1,OBJ_ARROW,0,Time[0],ULR1);
          ObjectSet(tULR1,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tULR1,OBJPROP_COLOR,c.1);  
          ObjectSet(tULR1,OBJPROP_WIDTH,myBoxWidth);
      } 
      else
      {
         ObjectMove(tULR1,0,Time[0],ULR1);
      }
 
  
    if (ObjectFind(tLLR1) != 0)
      {
          ObjectCreate(tLLR1,OBJ_ARROW,0,Time[0],LLR1);
          ObjectSet(tLLR1,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLLR1,OBJPROP_COLOR,c.1);
          ObjectSet(tLLR1,OBJPROP_WIDTH,myBoxWidth);   
      } 
      else
      {
         ObjectMove(tLLR1,0,Time[0],LLR1);
      }
} // if( std.channel.1 != 0 ) 



if( std.channel.2 != 0 ) 
{

    
    if (ObjectFind(tULR2) != 0)
      {
          ObjectCreate(tULR2,OBJ_ARROW,0,Time[0],ULR2);
          ObjectSet(tULR2,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tULR2,OBJPROP_COLOR,c.2); 
          ObjectSet(tULR2,OBJPROP_WIDTH,myBoxWidth); 
      } 
      else
      {
         ObjectMove(tULR2,0,Time[0],ULR2);
      }
 

    
    if (ObjectFind(tLLR2) != 0)
      {
          ObjectCreate(tLLR2,OBJ_ARROW,0,Time[0],LLR2);
          ObjectSet(tLLR2,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLLR2,OBJPROP_COLOR,c.2);  
          ObjectSet(tLLR2,OBJPROP_WIDTH,myBoxWidth);
      } 
      else
      {
         ObjectMove(tLLR2,0,Time[0],LLR2);
      }
} // if( std.channel.2 != 0 ) 


if( std.channel.3 != 0 ) 
{


    if (ObjectFind(tULR3) != 0)
      {
          ObjectCreate(tULR3,OBJ_ARROW,0,Time[0],ULR3);
          ObjectSet(tULR3,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tULR3,OBJPROP_COLOR,c.3); 
          ObjectSet(tULR3,OBJPROP_WIDTH,myBoxWidth); 
      } 
      else
      {
         ObjectMove(tULR3,0,Time[0],ULR3);
      }
 

    
    if (ObjectFind(tLLR3) != 0)
      {
          ObjectCreate(tLLR3,OBJ_ARROW,0,Time[0],LLR3);
          ObjectSet(tLLR3,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLLR3,OBJPROP_COLOR,c.3);
          ObjectSet(tLLR3,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tLLR3,0,Time[0],LLR3);
      }
} // if( std.channel.3 != 0 ) 
    
    if (ObjectFind(OBJNAME+"M_LR") != 0)
      {
          ObjectCreate(OBJNAME+"M_LR",OBJ_ARROW,0,Time[0],LR.price.2);
          ObjectSet(OBJNAME+"M_LR",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(OBJNAME+"M_LR",OBJPROP_COLOR,LR.c);
          ObjectSet(OBJNAME+"M_LR",OBJPROP_WIDTH,myBoxWidth);   
      } 
      else
      {
         ObjectMove(OBJNAME+"M_LR",0,Time[0],LR.price.2);
      } 
}

      
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+