//+------------------------------------------------------------------+
//|   TRO_Fractal                                                    |
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 2
#property indicator_color1 MediumVioletRed 
#property indicator_color2 DodgerBlue 

//+--------- TRO MODIFICATION ---------------------------------------+ 
extern bool   Sound.Alert        = false ;

extern bool   Show.Legend        = true ;
extern bool   Show.Trendlines    = true; 
extern bool   Show.Retracelines  = true; 
extern bool   Show.Targetlines   = true; 
extern bool   Show.Medianline    = true; 

extern int yIncLegend  = 200 ;

extern int BarsAgo   = 100 ;
extern int myPeriod  = 0 ;

extern int myThreshold      = 1;
extern int myRetracePips    = 20;
extern int myTargetPips     = 20;

extern int Symbol_1_Kod=217; //140
extern int Symbol_2_Kod=218; // 141


extern color colorFractalHigh    = MediumVioletRed ;
extern color colorFractalLow     = DodgerBlue ;
 
extern int myStyle  = 0 ; 
extern int myWidth  = 4 ; 





//extern string myUpperTrendLineName  = "UpperTrendLine001";
extern color  myUpperTrendLineColor = MediumVioletRed; 
extern int    myUpperTrendLineStyle = STYLE_SOLID;
extern int    myUpperTrendLineWidth = 2;
extern string myUpperSoundFile      = "ahooga.wav";

//extern string myLowerTrendLineName  = "LowerTrendLine001";
extern color  myLowerTrendLineColor = DodgerBlue; 
extern int    myLowerTrendLineStyle = STYLE_SOLID;
extern int    myLowerTrendLineWidth = 2;
extern string myLowerSoundFile      = "siren.wav";

extern color  myRetraceLineColor = DarkOrange; 
extern int    myRetraceLineStyle = STYLE_DOT;
extern int    myRetraceLineWidth = 1;

extern color  myTargetLineColor = DarkViolet; 
extern int    myTargetLineStyle = STYLE_DOT;
extern int    myTargetLineWidth = 1;


extern color  myMedianLineColor = LawnGreen; 
extern int    myMedianLineStyle = STYLE_DOT;
extern int    myMedianLineWidth = 1;

//---- input parameters 
 
 
//+--------- TRO MODIFICATION ---------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

int OldBars = -1 ;

color tColor = Yellow ;

int i, j, k, tltop, tlbot;
  

bool roll ;

double point ;
double upperTL[2], lowerTL[2];
double UpperTrendLinePrice, LowerTrendLinePrice, UpperLimit, LowerLimit, xThreshold;
double UpperRetracePrice, LowerRetracePrice, xRetracePips ;
double pUpperTargetPrice, pLowerTargetPrice, UpperTargetPrice, LowerTargetPrice, xTargetPips ;

datetime upperTLtime[2], lowerTLtime[2], upperStime, upperEtime, lowerStime, lowerEtime;
 
string TAG = "frac", OBJ001, OBJ002, OBJ003, OBJ004, OBJ005, OBJ006 ;  
string OBJ007, OBJ008 ;   
 
 
double UpperBuffer[];
double LowerBuffer[];
double UpperFractal,LowerFractal ;  


double midpoint, midstart ; 
datetime midstarttime,midendtime ;  
 
//+------------------------------------------------------------------+ 
int init() 
  { 
//+--------- TRO MODIFICATION ---------------------------------------+  
   period       = Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;   
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   
   tShortName = "frac"+ symbol + tChartPeriod  ;
    
   xThreshold   = myThreshold * point ;   
   xRetracePips = myRetracePips * point ;  
   xTargetPips = myTargetPips * point ; 
 
   OBJ001       = TAG + "001";
   OBJ002       = TAG + "002";  
   OBJ003       = TAG + "003";
   OBJ004       = TAG + "004";  
   OBJ005       = TAG + "005";
   OBJ006       = TAG + "006";  
   OBJ007       = TAG + "007";
   OBJ008       = TAG + "008";  
 

   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } 
      
     period = Period() ;    
   
   tChartPeriod =  TimeFrameToString(period) ;   
   
   string short_name="frac";
   IndicatorShortName(short_name);

   SetIndexStyle(0, DRAW_ARROW,myStyle,myWidth,colorFractalHigh);
   SetIndexArrow(0,Symbol_1_Kod);   
   SetIndexBuffer(0, UpperBuffer);
 
 
   SetIndexStyle(1, DRAW_ARROW,myStyle,myWidth,colorFractalLow);
   SetIndexArrow(1,Symbol_2_Kod);  
   SetIndexBuffer(1, LowerBuffer);         
   return(0); 
  } 

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}
    
//+------------------------------------------------------------------+
int deinit()
{
   Comment("") ;
       
   ObDeleteObjectsByPrefix(TAG);  
   
   TRO() ;
   
   return(0);
}

//+------------------------------------------------------------------+ 
int start() 
  { 
   

  deinit() ;  
 
UpperFractal = 0 ; 
LowerFractal = 0 ;

   int i;
   
      i = BarsAgo;
      
   while(i >= 0)
   {   
       UpperFractal = iFractals(symbol, period, MODE_UPPER, i);
   
       if(UpperFractal > 0) { UpperBuffer[i] = iHigh(symbol, period, i) ; } else { UpperBuffer[i] = 0 ; } 
            
       LowerFractal = iFractals(symbol, period, MODE_LOWER, i);
        
       if(LowerFractal > 0) { LowerBuffer[i] = iLow(symbol, period, i) ; } else { LowerBuffer[i] = 0 ; } 
     
       i--;
     }     
    


 if(Show.Legend) { DoShowLegend () ; }
  

   if(Show.Trendlines)
   {
      tltop = 0 ; 
      tlbot = 0 ;
   
   for( j=0; j<1000; j++ )
   {   
      while(true)
      {
         if( LowerBuffer[j] != 0 && tlbot < 2 ) {lowerTLtime[tlbot] = Time[j] ; lowerTL[tlbot] = LowerBuffer[j] ; tlbot = tlbot + 1 ; break ; }
         if( UpperBuffer[j] != 0 && tltop < 2 ) {upperTLtime[tltop] = Time[j] ; upperTL[tltop] = UpperBuffer[j] ; tltop = tltop + 1 ; break ; }         
          break ;
      } // while
      
      if( tlbot >=2 && tltop >= 2 ) { break ;  }
   } // for j   
      

   DrawPriceTrendLines(OBJ001, upperTLtime[1], upperTLtime[0], upperTL[1], 
                        upperTL[0], myUpperTrendLineColor, myUpperTrendLineStyle, myUpperTrendLineWidth) ;

   DrawPriceTrendLines(OBJ002, lowerTLtime[1], lowerTLtime[0], lowerTL[1], 
                        lowerTL[0], myLowerTrendLineColor, myLowerTrendLineStyle, myLowerTrendLineWidth) ;

   DrawPriceTrendLines(OBJ003, upperTLtime[0], Time[0], upperTL[0], 
                        upperTL[0], myUpperTrendLineColor, myUpperTrendLineStyle, myUpperTrendLineWidth) ;

   DrawPriceTrendLines(OBJ004, lowerTLtime[0], Time[0], lowerTL[0], 
                        lowerTL[0], myLowerTrendLineColor, myLowerTrendLineStyle, myLowerTrendLineWidth) ;

   if(Show.Medianline)
   {
   midpoint = MathAbs(upperTL[0] + lowerTL[0]) * 0.50 ;
   
   
   for( j=0; j<1000; j++ )
   {  
      if(Time[j] > upperTLtime[0] && Time[j] > lowerTLtime[0]) { continue ; } 
      if( midpoint < High[j] && midpoint > Low[j] ) { break ; }
    
   }
   
   if( lowerTLtime[0] > upperTLtime[0]  ) { midstarttime = lowerTLtime[1] ; midstart = lowerTL[1] ;}
   else                                   { midstarttime = upperTLtime[1] ; midstart = upperTL[1] ;  }   
   
   midendtime = Time[j] ; 
   
//   if( lowerTLtime[1] > upperTLtime[1]  ) { midendtime = lowerTLtime[j] ;  }
//   else                                   { midendtime = upperTLtime[j] ;  }
    
   
   DrawPriceTrendLines(OBJ004+"pf", midstarttime, midendtime, midstart, 
                        midpoint, myMedianLineColor, myMedianLineStyle, myMedianLineWidth) ;

   } // if

   if(Show.Retracelines)
   {
   UpperRetracePrice = upperTL[0] - xRetracePips ;
   LowerRetracePrice = lowerTL[0] + xRetracePips ;
   
//   if( upperTLtime[0] == Time[0] ) { upperStime = Time[1] ;  } else { upperStime = upperTLtime[0] ;  } 
   
   DrawPriceTrendLines(OBJ005, upperTLtime[0], Time[0], UpperRetracePrice, 
                        UpperRetracePrice, myRetraceLineColor, myRetraceLineStyle, myRetraceLineWidth) ;

   DrawPriceTrendLines(OBJ006, lowerTLtime[0], Time[0], LowerRetracePrice, 
                        LowerRetracePrice, myRetraceLineColor, myRetraceLineStyle, myRetraceLineWidth) ;
   }

   if(Show.Targetlines)
   {
   pUpperTargetPrice = UpperTargetPrice ;
   pLowerTargetPrice = LowerTargetPrice ;
   
   UpperTargetPrice = upperTL[0] + xTargetPips ;
   LowerTargetPrice = lowerTL[0] - xTargetPips ;
   
   DrawPriceTrendLines(OBJ007, upperTLtime[0], Time[0], pUpperTargetPrice, 
                        pUpperTargetPrice, myTargetLineColor, myTargetLineStyle, myTargetLineWidth) ;

   DrawPriceTrendLines(OBJ008, lowerTLtime[0], Time[0], pLowerTargetPrice, 
                        pLowerTargetPrice, myTargetLineColor, myTargetLineStyle, myTargetLineWidth) ;
   }

      UpperTrendLinePrice = ObjectGetValueByShift(OBJ001, 0);
      
      LowerTrendLinePrice = ObjectGetValueByShift(OBJ002, 0);
           
      UpperLimit = Ask + xThreshold ;
      LowerLimit = Bid - xThreshold ;


   if(Sound.Alert)
   {      
      if( UpperTrendLinePrice >= LowerLimit && UpperTrendLinePrice <= UpperLimit )
      {
         PlaySound(myUpperSoundFile);
      } 
      
      if( LowerTrendLinePrice >= LowerLimit && LowerTrendLinePrice <= UpperLimit )
      {
         PlaySound(myLowerSoundFile);
      } 

      if( upperTL[0] >= LowerLimit && upperTL[0] <= UpperLimit )
      {
         PlaySound(myUpperSoundFile);
      } 
      
      if( lowerTL[0] >= LowerLimit && lowerTL[0] <= UpperLimit )
      {
         PlaySound(myLowerSoundFile);
      } 
            
      
   } // if(Sound.Alert) 
   
 
   } // if 
    
    
   OldBars = Bars ;   

//+--------- TRO MODIFICATION ---------------------------------------+        

  

          
   return(0);
}

//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
 

 
//+------------------------------------------------------------------+
 

void DrawPriceTrendLines(string objname, datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, int style, int width)
  {
    
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(objname, OBJPROP_RAY, true);
 
   ObjectSet(objname, OBJPROP_COLOR, lineColor);
   ObjectSet(objname, OBJPROP_STYLE, style);
   ObjectSet(objname, OBJPROP_WIDTH, width);
  }
 
//+------------------------------------------------------------------+  
void DoShowLegend()
{ 
   

   setObject(TAG+"ut","Upper Target  " + DoubleToStr(pUpperTargetPrice, digits) ,30,yIncLegend,myTargetLineColor); setObject(TAG+"ut1","l",10,yIncLegend,myTargetLineColor     ,"Wingdings");
   setObject(TAG+"us","Upper Fractal " + DoubleToStr(upperTL[0], digits) ,30,yIncLegend+20,myUpperTrendLineColor); setObject(TAG+"us1","l",10,yIncLegend+20,myUpperTrendLineColor     ,"Wingdings");
   setObject(TAG+"ur","Upper Retrace " + DoubleToStr(UpperRetracePrice, digits) ,30,yIncLegend+40,myRetraceLineColor); setObject(TAG+"ur1","l",10,yIncLegend+40,myRetraceLineColor     ,"Wingdings");
   
   setObject(TAG+"lr","Lower Retrace " + DoubleToStr(LowerRetracePrice, digits) ,30,yIncLegend+60,myRetraceLineColor); setObject(TAG+"lr1","l",10,yIncLegend+60,myRetraceLineColor     ,"Wingdings");   
   setObject(TAG+"ls","Lower Fractal " + DoubleToStr(lowerTL[0], digits) ,30,yIncLegend+80,myLowerTrendLineColor); setObject(TAG+"ls1","l",10,yIncLegend+80,myLowerTrendLineColor     ,"Wingdings");
   setObject(TAG+"lt","Lower Target  " + DoubleToStr(pLowerTargetPrice, digits) ,30,yIncLegend+100,myTargetLineColor); setObject(TAG+"lt1","l",10,yIncLegend+100,myTargetLineColor     ,"Wingdings");           

   setObject(TAG+"ml","Median Line   " + DoubleToStr(midpoint, digits) ,30,yIncLegend+120,myMedianLineColor); setObject(TAG+"ml1","l",10,yIncLegend+120,myMedianLineColor     ,"Wingdings");           
         
     
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,0,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,0);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}

//+------------------------------------------------------------------+
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+   

/*



Comment(
"tltop " , tltop , "\n" , 
"tlbot " , tlbot , "\n" , 
 
"upperTLtime[0] " , TimeToStr( upperTLtime[0] ) , "\n" ,  
"upperTLtime[1] " , TimeToStr( upperTLtime[1] ) , "\n" ,  
 
"upperTL[0] " , DoubleToStr(  upperTL[0],Digits) , "\n" , 
"upperTL[1] " , DoubleToStr(  upperTL[1],Digits) , "\n" ,  
"") ; 
      if ( Trigger1 ) 
      { 
        if( FP_BuferUp[0] != 0 ) { DoRollMsg( "top 1" ) ; Trigger1 = False ; if(Sound.Alert) {Alert(symbol,"  ", tChartPeriod, " Level 1 Lower "+ DoubleToStr(Close[0] ,digits));} }
        if( FP_BuferDn[0] != 0 ) { DoRollMsg( "bot 1" ) ; Trigger1 = False ; if(Sound.Alert) {Alert(symbol,"  ", tChartPeriod, " Level 1 Upper "+ DoubleToStr(Close[0] ,digits)); } }
      }
      
      if ( Trigger2 ) 
      {
        if( NP_BuferUp[0] != 0 ) { DoRollMsg( "top 2" ) ; Trigger2 = False ; if(Sound.Alert) {Alert(symbol,"  ", tChartPeriod, " Level 2 Lower "+ DoubleToStr(Close[0] ,digits)); } }
        if( NP_BuferDn[0] != 0 ) { DoRollMsg( "bot 2" ) ; Trigger2 = False ; if(Sound.Alert) {Alert(symbol,"  ", tChartPeriod, " Level 2 Upper "+ DoubleToStr(Close[0] ,digits)); } }
      }
      
      if ( Trigger3 ) 
      {     
        if( HP_BuferUp[0] != 0 ) { DoRollMsg( "top 3" ) ; Trigger3 = False ; if(Sound.Alert) {Alert(symbol,"  ", tChartPeriod, " Level 3 Lower "+ DoubleToStr(Close[0] ,digits)); } }
        if( HP_BuferDn[0] != 0 ) { DoRollMsg( "bot 3" ) ; Trigger3 = False ; if(Sound.Alert) {Alert(symbol,"  ", tChartPeriod, " Level 3 Upper "+ DoubleToStr(Close[0] ,digits)); } }
      }



if(Symbol() == "GBPUSD" && Period() == 60)
{
Comment(
Symbol(), Period(),   "\n" ,  
"FP_BuferUp[0] " , DoubleToStr( FP_BuferUp[0] ,Digits) , "\n" ,   
"FP_BuferDn[0] " , DoubleToStr( FP_BuferDn[0] ,Digits) , "\n" , 

"NP_BuferUp[0] " , DoubleToStr( NP_BuferUp[0] ,Digits) , "\n" ,   
"NP_BuferDn[0] " , DoubleToStr( NP_BuferDn[0] ,Digits) , "\n" ,   

"HP_BuferUp[0] " , DoubleToStr( HP_BuferUp[0] ,Digits) , "\n" ,   
"HP_BuferDn[0] " , DoubleToStr( HP_BuferDn[0] ,Digits) , "\n" , 
 
"") ; 
}      
  
Comment(

"zzz = " , zzz , "\n" ,

"FP_BuferUp[zzz] " , DoubleToStr( FP_BuferUp[zzz] ,Digits) , "\n" ,   
"FP_BuferDn[zzz] " , DoubleToStr( FP_BuferDn[zzz] ,Digits) , "\n" , 

"NP_BuferUp[zzz] " , DoubleToStr( NP_BuferUp[zzz] ,Digits) , "\n" ,   
"NP_BuferDn[zzz] " , DoubleToStr( NP_BuferDn[zzz] ,Digits) , "\n" ,   

"HP_BuferUp[zzz] " , DoubleToStr( HP_BuferUp[zzz] ,Digits) , "\n" ,   
"HP_BuferDn[zzz] " , DoubleToStr( HP_BuferDn[zzz] ,Digits) , "\n" , 
  
"") ;


extern bool   Show.Targetlines  = true; 

extern color  myTargetLineColor = Orange; 
extern int    myTargetLineStyle = STYLE_DOT;
extern int    myTargetLineWidth = 1;

extern int    myTargetPips    = 20;

double UpperTargetPrice, LowerTargetPrice, xTargetPips ;

string OBJ007, OBJ008 ;  

   xTargetPips = myTargetPips * point ; 

   if(Show.Targetlines)
   {
   UpperTargetPrice = upperTL[0] - xTargetPips ;
   LowerTargetPrice = lowerTL[0] + xTargetPips ;
   
   DrawPriceTrendLines(OBJ007, upperTLtime[0], Time[0], UpperTargetPrice, 
                        UpperTargetPrice, myTargetLineColor, myTargetLineStyle, myTargetLineWidth) ;

   DrawPriceTrendLines(OBJ008, lowerTLtime[0], Time[0], LowerTargetPrice, 
                        LowerTargetPrice, myTargetLineColor, myTargetLineStyle, myTargetLineWidth) ;
   }


*/