//+------------------------------------------------------------------+ 
//|   TRO_VOLUME_FORCE                                               | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

#property indicator_separate_window
#property indicator_buffers 2

extern bool Show.Message = true ; 
//extern bool   Send.Mail      = false ;
//extern bool   Sound.Alert    = false ;
 
extern color VolumeForceUpColor = DeepSkyBlue;
extern color VolumeForceDnColor  = DeepPink;
extern color NoSignalColor    = DimGray;

extern int   SymbolWidth  = 2 ;

//+------------------------------------------------------------------+
 
double BufUp[], BufDn[];

string symbol, tChartPeriod,  tShortName , TAG, tObjName06,  short_name, TheMessage, tForce;  
int    digits, period, digits2  ; 
double point ;

double  cVOLUME, pVOLUME, O,C,H, L, H1, L1, cRANGE, pRANGE;

bool win, sincebull, sincebear , VolumeForceDn, VolumeForceUp, oneHigh = false , oneLow = false ; 
color TheColor ; 
 
datetime Trigger ; 
 
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
      
      SetIndexBuffer(0,BufUp);
      SetIndexStyle(0,DRAW_HISTOGRAM,0,SymbolWidth,VolumeForceUpColor);
      SetIndexLabel(0,"VolumeForceUp");
      
      SetIndexBuffer(1,BufDn);
      SetIndexStyle(1,DRAW_HISTOGRAM,0,SymbolWidth,VolumeForceDnColor);
      SetIndexLabel(1,"VolumeForceDn");
      
      TAG = "volforce" ;

      tObjName06 = TAG + "06" ;        

   short_name = "Volume Force " ;
   
   IndicatorShortName(short_name);

   TRO() ; 

   return(0);
  } 
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  } 
//+------------------------------------------------------------------+
int start()
{
   win =    WindowFind(short_name);     
   int limit;
   int counted_bars=IndicatorCounted();

   if(counted_bars>0) counted_bars--;
   
   limit = Bars - counted_bars - 1; //Bars-counted_bars;


   for(int i=limit; i>=0; i--)   
   {
      cVOLUME = iVolume(symbol,period,i); 
        
   
      O = iOpen(symbol,period,i);
      H = iHigh(symbol,period,i);
      L = iLow(symbol,period,i);      
      C = iClose(symbol,period,i);
 
      VolumeForceDn = C < O ;   
      VolumeForceUp = C > O ; 
      
      while(true)
      {
         if (VolumeForceDn)
         { 
            sincebear = i ; 
            oneLow  = true ; 
            BufDn[i] = (O - C)/point * cVOLUME ;  
            BufUp[i] = EMPTY_VALUE ; 
            TheColor = VolumeForceDnColor ; 
            TheMessage = "Volume Force Down" ;
            break ; 
         }
         
         if (VolumeForceUp)
         { 
            sincebull = i ;   
            oneHigh = true ; 
            BufUp[i] = (C - O)/point * cVOLUME ;  
            BufDn[i] = EMPTY_VALUE ; 
            TheColor = VolumeForceUpColor ; 
            TheMessage = "Volume Force Up"  ;          
            break ; 
         }
         
         TheColor = NoSignalColor ;
         BufUp[i] = EMPTY_VALUE ; BufDn[i] = EMPTY_VALUE ; break ;
 
      } // while
          
  } // for
 
   sincebull = -1 ;
   sincebear = -1 ;
 
   for( i=0; i<1000; i++)   
   { 
      if(sincebull == -1 && BufUp[i] != EMPTY_VALUE) { sincebull = i ; }
      if(sincebear == -1 && BufDn[i] != EMPTY_VALUE) { sincebear = i ; }
      if(sincebull > -1 && sincebear > -1) { break ; }                  
   } // for
  
//  if( Sound.Alert ) { DoAlert() ; }
  

   if( MathMax(BufUp[0],BufDn[0]) > MathMax(BufUp[1],BufDn[1]) ) { TheMessage = TheMessage + " Stronger" ; }
   else { TheMessage = TheMessage + " Weaker" ; }

   if(  Show.Message ) { DoShowMessage() ; } 
 
   WindowRedraw() ;
   
    
//----
   return(0);
}

//+------------------------------------------------------------------+  
void DoShowMessage()
{ 

int yInc = 1 ;

   setObject(TAG+"cur",TheMessage ,50,yInc,TheColor, "Impact", 15);  

   yInc = yInc + 25 ; 
   setObject(TAG+"bull","Force Up" ,50,yInc,VolumeForceUpColor); setObject(TAG+"bull1",sincebull ,11,yInc,VolumeForceUpColor ,"Courier New");

   yInc = yInc + 15 ; 
   setObject(TAG+"bear","Force Dn" ,50,yInc,VolumeForceDnColor); setObject(TAG+"bear1",sincebear ,11,yInc,VolumeForceDnColor ,"Courier New");
       
       
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}  
//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+

/*
   i = 0 ;
Comment(
"i " , i , "\n" ,
"oneLow " , oneLow , "\n" ,
"oneHigh " , oneHigh , "\n" ,
"VolumeForceDn" , VolumeForceDn, "\n" ,
"VolumeForceUp " , VolumeForceUp , "\n" ,
"BufDn[i] " , DoubleToStr(BufDn[i],Digits) , "\n" ,
"BufUp[i] " , DoubleToStr(BufUp[i],Digits) , "\n" ,
 
"") ;
      
      BufUp[i] = EMPTY_VALUE ; 
      BufDn[i] = EMPTY_VALUE ;
   
   
 
//+------------------------------------------------------------------+
void DoAlert()    
{

if ( Trigger != Time[0] ) 
{
  if( Sound.Alert )
  {
    if( VolumeForceUp ) { Trigger = Time[0] ; Alert(symbol,"  ",  " Stop Volume High " + DoubleToStr(Close[0] ,digits)); }
    if( VolumeForceDn)  { Trigger = Time[0] ; Alert(symbol,"  ",  " Stop Volume Low "+ DoubleToStr(Close[0] ,digits)); }     
  }
  
  if( Send.Mail )
  {
    if( VolumeForceUp ) { Trigger = Time[0] ; SendMail(symbol,  "Stop Volume High "); }
    if( VolumeForceDn)  { Trigger = Time[0] ; SendMail(symbol,  "Stop Volume Low "); }     
  }  
  
} // if


} // void  


   sincebull = -1 ;
   sincebear = -1 ;
 
   for( i=0; i<1000; i++)   
   { 
      if(sincebull == -1 && BufUp[i] != EMPTY_VALUE) { sincebull = i ; }
      if(sincebear == -1 && BufDn[i] != EMPTY_VALUE) { sincebear = i ; }
      if(sincebull > -1 && sincebear > -1) { break ; }                  
   } // for    
*/